### Hierarchy

- Widget
  - ImagePWidget

### Implements

- IDisposable
- IMessageHandler

## Index

### Modules

- Widget

### Constructors

- constructor

### Properties

- disposed
- id
- isAttached
- isDisposed
- isHidden
- isVisible
- layout
- node
- parent
- title

### Methods

- addClass
- blur
- children
- clearFlag
- close
- contains
- dispose
- fit
- focus
- hasClass
- hide
- notifyLayout
- onAfterAttach
- onAfterShow
- onBeforeDetach
- onBeforeHide
- onBlurRequest
- onChildAdded
- onChildRemoved
- onCloseRequest
- onFocusRequest
- onResize
- onUpdateRequest
- processMessage
- removeClass
- setFlag
- setHidden
- show
- testFlag
- toggleClass
- update
- createNode

## Constructors

### constructor

- new ImagePWidget(options?: IOptions): ImagePWidget

- Inherited from Widget.__constructor

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:14

  Construct a new widget.

  #### Parameters

  - ##### Optional options: IOptions

    The options for initializing the widget.

  #### Returns ImagePWidget

## Properties

### disposed

disposed: ISignal<Widget, void>

Inherited from Widget.disposed

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:33

A signal emitted when the widget is disposed.

### id

id: string

Inherited from Widget.id

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:78

Set the id of the widget's DOM node.

### isAttached

isAttached: boolean

Inherited from Widget.isAttached

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:47

Test whether the widget's node is attached to the DOM.

#### Notes

This is a read-only property.

### isDisposed

isDisposed: boolean

Inherited from Widget.isDisposed

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:40

Test whether the widget has been disposed.

#### Notes

This is a read-only property.

### isHidden

isHidden: boolean

Inherited from Widget.isHidden

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:54

Test whether the widget is explicitly hidden.

#### Notes

This is a read-only property.

### isVisible

isVisible: boolean

Inherited from Widget.isVisible

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:64

Test whether the widget is visible.

#### Notes

A widget is visible when it is attached to the DOM, is not explicitly hidden, and has no explicitly hidden ancestors.

This is a read-only property.

### layout

layout: Layout

Inherited from Widget.layout

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:126

Set the layout for the widget.

#### Notes

The layout is single-use only. It cannot be set to `null` and it cannot be changed after the first assignment.

The layout is disposed automatically when the widget is disposed.

### node

node: HTMLElement

Inherited from Widget.node

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:71

Get the DOM node owned by the widget.

#### Notes

This is a read-only property.

### parent

parent: Widget

Inherited from Widget.parent

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:110

Set the parent of the widget.

#### Notes

Children are typically added to a widget by using a layout, which means user code will not normally set the parent widget directly.

The widget will be automatically removed from its old parent.

This is a no-op if there is no effective parent change.

### title

title: Title

Inherited from Widget.title

- Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:92

Get the title object for the widget.

#### Notes

The title object is used by some container widgets when displaying the widget alongside some title, such as a tab panel or side bar.

Since not all widgets will use the title, it is created on demand.

The `owner` property of the title is set to this widget.

This is a read-only property.

## Methods

### addClass

- addClass(name: string): void

- Inherited from Widget.addClass

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:164

  Add a class name to the widget's DOM node.

  #### Parameters

  - ##### name: string

    The class name to add to the node.

    #### Notes

    If the class name is already added to the node, this is a no-op.

    The class name must not contain whitespace.

  #### Returns void

### blur

- blur(): void

- Inherited from Widget.blur

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:218

  Send a `'blur-request'` message to the widget.

  #### Notes

  This is a simple convenience method for sending the message.

  #### Returns void

### children

- children(): IIterator<Widget>

- Inherited from Widget.children

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:137

  Create an iterator over the widget's children.

  #### Returns IIterator<Widget>

  A new iterator over the children of the widget.

  #### Notes

  The widget must have a populated layout in order to have children.

  If a layout is not installed, the returned iterator will be empty.

### clearFlag

- clearFlag(flag: WidgetFlag): void

- Inherited from Widget.clearFlag

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:273

  Clear the given widget flag.

  #### Notes

  This will not typically be called directly by user code.

  #### Parameters

  - ##### flag: WidgetFlag

  #### Returns void

### close

- close(): void

- Inherited from Widget.close

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:225

  Send a `'close-request'` message to the widget.

  #### Notes

  This is a simple convenience method for sending the message.

  #### Returns void

### contains

- contains(widget: Widget): boolean

- Inherited from Widget.contains

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:145

  Test whether a widget is a descendant of this widget.

  #### Parameters

  - ##### widget: Widget

    The descendant widget of interest.

  #### Returns boolean

  `true` if the widget is a descendant, `false` otherwise.

### dispose

- dispose(): void

- Inherited from Widget.dispose

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:29

  Dispose of the widget and its descendant widgets.

  #### Notes

  It is unsafe to use the widget after it has been disposed.

  All calls made to this method after the first are a no-op.

  #### Returns void

### fit

- fit(): void

- Inherited from Widget.fit

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:204

  Post a `'fit-request'` message to the widget.

  #### Notes

  This is a simple convenience method for posting the message.

  #### Returns void

### focus

- focus(): void

- Inherited from Widget.focus

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:211

  Send a `'focus-request'` message to the widget.

  #### Notes

  This is a simple convenience method for sending the message.

  #### Returns void

### hasClass

- hasClass(name: string): boolean

- Inherited from Widget.hasClass

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:153

  Test whether the widget's DOM node has the given class name.

  #### Parameters

  - ##### name: string

    The class name of interest.

  #### Returns boolean

  `true` if the node has the class, `false` otherwise.

### hide

- hide(): void

- Inherited from Widget.hide

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:243

  Hide the widget and make it hidden to its parent widget.

  #### Notes

  This causes the isHidden property to be `true`.

  If the widget is explicitly hidden, this is a no-op.

  #### Returns void

### Protected notifyLayout

- notifyLayout(msg: Message): void

- Inherited from Widget.notifyLayout

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:293

  Invoke the message processing routine of the widget's layout.

  #### Parameters

  - ##### msg: Message

    The message to dispatch to the layout.

    #### Notes

    This is a no-op if the widget does not have a layout.

    This will not typically be called directly by user code.

  #### Returns void

### Protected onAfterAttach

- onAfterAttach(msg: Message): void

- Inherited from Widget.onAfterAttach

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:349

  A message handler invoked on an `'after-attach'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onAfterShow

- onAfterShow(msg: Message): void

- Inherited from Widget.onAfterShow

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:335

  A message handler invoked on an `'after-show'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onBeforeDetach

- onBeforeDetach(msg: Message): void

- Inherited from Widget.onBeforeDetach

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:356

  A message handler invoked on a `'before-detach'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onBeforeHide

- onBeforeHide(msg: Message): void

- Inherited from Widget.onBeforeHide

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:342

  A message handler invoked on a `'before-hide'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onBlurRequest

- onBlurRequest(msg: Message): void

- Inherited from Widget.onBlurRequest

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:307

  A message handler invoked on a `'blur-request'` message.

  #### Notes

  The default implementation blurs the widget's node.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onChildAdded

- onChildAdded(msg: ChildMessage): void

- Inherited from Widget.onChildAdded

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:363

  A message handler invoked on a `'child-added'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: ChildMessage

  #### Returns void

### Protected onChildRemoved

- onChildRemoved(msg: ChildMessage): void

- Inherited from Widget.onChildRemoved

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:370

  A message handler invoked on a `'child-removed'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: ChildMessage

  #### Returns void

### Protected onCloseRequest

- onCloseRequest(msg: Message): void

- Inherited from Widget.onCloseRequest

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:314

  A message handler invoked on a `'close-request'` message.

  #### Notes

  The default implementation unparents or detaches the widget.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onFocusRequest

- onFocusRequest(msg: Message): void

- Inherited from Widget.onFocusRequest

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:300

  A message handler invoked on a `'focus-request'` message.

  #### Notes

  The default implementation focuses the widget's node.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### Protected onResize

- onResize(msg: ResizeMessage): void

- Inherited from Widget.onResize

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:321

  A message handler invoked on a `'resize'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: ResizeMessage

  #### Returns void

### Protected onUpdateRequest

- onUpdateRequest(msg: Message): void

- Inherited from Widget.onUpdateRequest

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:328

  A message handler invoked on an `'update-request'` message.

  #### Notes

  The default implementation of this handler is a no-op.

  #### Parameters

  - ##### msg: Message

  #### Returns void

### processMessage

- processMessage(msg: Message): void

- Inherited from Widget.processMessage

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:282

  Process a message sent to the widget.

  #### Parameters

  - ##### msg: Message

    The message sent to the widget.

    #### Notes

    Subclasses may reimplement this method as needed.

  #### Returns void

### removeClass

- removeClass(name: string): void

- Inherited from Widget.removeClass

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:175

  Remove a class name from the widget's DOM node.

  #### Parameters

  - ##### name: string

    The class name to remove from the node.

    #### Notes

    If the class name is not yet added to the node, this is a no-op.

    The class name must not contain whitespace.

  #### Returns void

### setFlag

- setFlag(flag: WidgetFlag): void

- Inherited from Widget.setFlag

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:266

  Set the given widget flag.

  #### Notes

  This will not typically be called directly by user code.

  #### Parameters

  - ##### flag: WidgetFlag

  #### Returns void

### setHidden

- setHidden(hidden: boolean): void

- Inherited from Widget.setHidden

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:252

  Show or hide the widget according to a boolean value.

  #### Parameters

  - ##### hidden: boolean

    `true` to hide the widget, or `false` to show it.

    #### Notes

    This is a convenience method for `hide()` and `show()`.

  #### Returns void

### show

- show(): void

- Inherited from Widget.show

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:234

  Show the widget and make it visible to its parent widget.

  #### Notes

  This causes the isHidden property to be `false`.

  If the widget is not explicitly hidden, this is a no-op.

  #### Returns void

### testFlag

- testFlag(flag: WidgetFlag): boolean

- Inherited from Widget.testFlag

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:259

  Test whether the given widget flag is set.

  #### Notes

  This will not typically be called directly by user code.

  #### Parameters

  - ##### flag: WidgetFlag

  #### Returns boolean

### toggleClass

- toggleClass(name: string, force?: boolean): boolean

- Inherited from Widget.toggleClass

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:190

  Toggle a class name on the widget's DOM node.

  #### Parameters

  - ##### name: string

    The class name to toggle on the node.

  - ##### Optional force: boolean

    Whether to force add the class (`true`) or force remove the class (`false`). If not provided, the presence of the class will be toggled from its current state.

  #### Returns boolean

  `true` if the class is now present, `false` otherwise.

  #### Notes

  The class name must not contain whitespace.

### update

- update(): void

- Inherited from Widget.update

  - Defined in /Users/jgrout6/projects/app/ipywidgets/jupyter-js-widgets/node_modules/phosphor/lib/ui/widget.d.ts:197

  Post an `'update-request'` message to the widget.

  #### Notes

  This is a simple convenience method for posting the message.

  #### Returns void

### Static createNode

- createNode(): HTMLImageElement

- - Defined in widget_image.ts:30

  #### Returns HTMLImageElement

Generated using TypeDoc